<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-8 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6 text-center"
          >
          Adjuntar Documentos de Admisión
          </div>
        </q-card-section>
        <q-card-section>
          <div
            class="text-h8 text-center">
          Todos los documentos adjuntados deben de ser documentos <strong>PDF</strong>, escanea tus documentos y adjunta aqui tus datos<br/>
          Cada archivo debe de contener el nombre de <strong>TipoDeDocumento.PDF</strong><br/>Ej: Cedula.PDF / CopiaDeTitulo.PDF
          </div>
        </q-card-section>
        <q-card-section>
          <br/>
          <div class="row items-start">
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Documento de Identificación</strong>
              <q-input type="file" v-model="documents.ci" filled :error="$v.documents.ci.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Copia de la partida de Nacimiento</strong>
              <q-input type="file" v-model="documents.partideN" filled :error="$v.documents.partideN.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Certificado de Bautizo</strong>
              <q-input type="file" v-model="documents.certificadoB" filled :error="$v.documents.certificadoB.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Copia de Titulo de Educacion Media</strong>
              <q-input type="file" v-model="documents.title" filled :error="$v.documents.title.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Fondo Negro del Titulo</strong>
              <q-input type="file" v-model="documents.fondoNegro" filled :error="$v.documents.fondoNegro.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Copia de Notas certificadas</strong>
              <q-input type="file" v-model="documents.copyNotes" filled :error="$v.documents.copyNotes.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Certificado de Participacion (SNI)</strong>
              <q-input type="file" v-model="documents.sni" filled :error="$v.documents.sni.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Copia de Inscripción Militar</strong>
              <q-input type="file" v-model="documents.inscriptionMilitar" filled :error="$v.documents.inscriptionMilitar.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Foto Tipo Carnet Actualizada</strong>
              <q-input type="file" v-model="documents.photo" filled :error="$v.documents.photo.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Carta de Recomendación</strong>
              <q-input type="file" v-model="documents.carteRecomendate" filled :error="$v.documents.carteRecomendate.$error" error-message="Archivo necesario"/>
          </div>
          <!--- Datos para estudiantes del seminario --->
          <template v-if="band2">
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Certificado de Guia Mayor</strong>
              <q-input type="file" v-model="teology.old" filled :error="$v.teology.old.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Certificado de Anciano</strong>
              <q-input type="file" v-model="teology.guieMore" filled :error="$v.teology.guieMore.$error" error-message="Archivo necesario"/>
          </div>
            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
              <strong>Certificado de Colportaje</strong>
              <q-input type="file" v-model="teology.colportage" filled :error="$v.teology.colportage.$error" error-message="Archivo necesario"/>
          </div>
          </template>
          <div>
          </div>
          </div>
          <div class="row">
          <q-btn class="bg-primary text-white col self-end" flat @click="sendDocuments()">
            Enviar
          </q-btn>
          </div>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<script>
import { required } from 'vuelidate/lib/validators'
import { mapGetters } from 'vuex'
export default {
  data () {
    return {
      documents: {},
      students: [],
      Copystudents: {},
      folder: {
        dir: '',
        user_id: '',
        file: ''
      },
      band2: false,
      teology: {}
    }
  },
  validations: {
    documents: {
      ci: {
        required
      },
      partideN: {
        required
      },
      certificadoB: {
        required
      },
      title: {
        required
      },
      fondoNegro: {
        required
      },
      copyNotes: {
        required
      },
      sni: {
        required
      },
      inscriptionMilitar: {
        required
      },
      photo: {
        required
      },
      carteRecomendate: {
        required
      }
    },
    teology: {
      old: {
        required
      },
      guieMore: {
        required
      },
      colportage: {
        required
      }
    }
  },
  mounted () {
    this.getBack()
  },
  computed: {
    ...mapGetters('generals', ['student'])
  },
  methods: {
    getBack () {
      this.$q.loading.show()
      this.$api.get('GetStudent_id/' + this.student).then(res => {
        this.students = res
        this.Copystudents = this.students[0]
        if (this.Copystudents.carrer === 'SETAVEN') {
          this.band2 = true
        }
        this.$q.loading.hide()
      })
    },
    verify () {
      console.log(this.documents)
      let band = true
      if ((this.documents.ci[0].name.substr(this.documents.ci[0].name.length - 3, this.documents.ci[0].name.length)) !== 'pdf') {
        band = false
        this.documents.ci = null
      } else if ((this.documents.partideN[0].name.substr(this.documents.partideN[0].name.length - 3, this.documents.partideN[0].name.length)) !== 'pdf') {
        band = false
        this.documents.partideN = null
      } else if ((this.documents.certificadoB[0].name.substr(this.documents.certificadoB[0].name.length - 3, this.documents.certificadoB[0].name.length)) !== 'pdf') {
        band = false
        this.documents.certificadoB = null
      } else if ((this.documents.title[0].name.substr(this.documents.title[0].name.length - 3, this.documents.title[0].name.length)) !== 'pdf') {
        band = false
        this.documents.title = null
      } else if ((this.documents.fondoNegro[0].name.substr(this.documents.fondoNegro[0].name.length - 3, this.documents.fondoNegro[0].name.length)) !== 'pdf') {
        band = false
        this.documents.fondoNegro = null
      } else if ((this.documents.copyNotes[0].name.substr(this.documents.copyNotes[0].name.length - 3, this.documents.copyNotes[0].name.length)) !== 'pdf') {
        band = false
        this.documents.copyNotes = null
      } else if ((this.documents.sni[0].name.substr(this.documents.sni[0].name.length - 3, this.documents.sni[0].name.length)) !== 'pdf') {
        band = false
        this.documents.sni = null
      } else if ((this.documents.inscriptionMilitar[0].name.substr(this.documents.inscriptionMilitar[0].name.length - 3, this.documents.inscriptionMilitar[0].name.length)) !== 'pdf') {
        band = false
        this.documents.inscriptionMilitar = null
      } else if ((this.documents.photo[0].name.substr(this.documents.photo[0].name.length - 3, this.documents.photo[0].name.length)) !== 'pdf') {
        band = false
        this.documents.photo = null
      } else if ((this.documents.carteRecomendate[0].name.substr(this.documents.carteRecomendate[0].name.length - 3, this.documents.carteRecomendate[0].name.length)) !== 'pdf') {
        band = false
        this.documents.carteRecomendate = null
      }
      if (!band) {
        this.$q.notify({
          position: 'center',
          textColor: 'white',
          icon: 'warning',
          color: 'negative',
          message: 'Solo se admiten documentos tipo pdf'
        })
        return band
      }
      return band
    },
    verify2 () {
      let band = true
      if (this.band2) {
        if ((this.teology.old[0].name.substr(this.teology.old[0].name.length - 3, this.teology.old[0].name.length)) !== 'pdf') {
          band = false
          this.teology.old = null
        } else if ((this.teology.guieMore[0].name.substr(this.teology.guieMore[0].name.length - 3, this.teology.guieMore[0].name.length)) !== 'pdf') {
          band = false
          this.teology.guieMore = null
        } else if ((this.teology.colportage[0].name.substr(this.teology.colportage[0].name.length - 3, this.teology.colportage[0].name.length)) !== 'pdf') {
          band = false
          this.teology.colportage = null
        }
      }
      if (!band) {
        this.$q.notify({
          position: 'center',
          textColor: 'white',
          icon: 'warning',
          color: 'negative',
          message: 'Solo se admiten documentos tipo pdf'
        })
        return band
      }
      return band
    },
    sendDocuments () {
      this.$v.documents.$touch()
      if (this.$v.documents.$error) {
        console.log('error')
      } else {
        if (this.verify()) {
          for (const i in this.documents) {
            console.log(this.documents[i])
            const formData = new FormData()
            switch (i) {
              case 'ci':
                formData.append('file', this.documents.ci[0])
                break
              case 'partideN':
                formData.append('file', this.documents.partideN[0])
                break
              case 'certificadoB':
                formData.append('file', this.documents.certificadoB[0])
                break
              case 'title':
                formData.append('file', this.documents.title[0])
                break
              case 'fondoNegro':
                formData.append('file', this.documents.fondoNegro[0])
                break
              case 'copyNotes':
                formData.append('file', this.documents.copyNotes[0])
                break
              case 'sni':
                formData.append('file', this.documents.sni[0])
                break
              case 'inscriptionMilitar':
                formData.append('file', this.documents.inscriptionMilitar[0])
                break
              case 'photo':
                formData.append('file', this.documents.photo[0])
                break
              case 'carteRecomendate':
                formData.append('file', this.documents.carteRecomendate[0])
                break
              default:
                break
            }
            this.$q.loading.show()
            this.$api.post('UploadFile', formData, {
              headers: {
                'Content-type': undefined
              }
            }).then(res => {
              this.$q.notify({
                position: 'center',
                textColor: 'white',
                icon: res.icon,
                color: res.color,
                message: res.message
              })
              switch (i) {
                case 'ci':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Cedula'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'partideN':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Partida de Nacimiento'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'certificadoB':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Bautizo'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'title':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Copia de Titulo de Educacion Media'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'fondoNegro':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Fondo Negro'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'copyNotes':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Copia de Notas Certificadas'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'sni':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Participación (SNI)'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'inscriptionMilitar':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Inscripción Militar'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'photo':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Foto Tipo Carnet'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'carteRecomendate':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Carta de Rocomendacion'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                default:
                  break
              }
              this.$router.push('IndexStudent')
              this.$q.loading.hide()
            })
          }
        }
      }
      if (this.band2) {
        this.sendDocuments_Teology()
      }
    },
    sendDocuments_Teology () {
      this.$v.teology.$touch()
      if (this.$v.teology.$error) {
        console.log('error')
      } else {
        if (this.verify2()) {
          for (const i in this.teology) {
            const formData = new FormData()
            switch (i) {
              case 'old':
                formData.append('file', this.teology.old[0])
                break
              case 'guieMore':
                formData.append('file', this.teology.guieMore[0])
                break
              case 'colportage':
                formData.append('file', this.teology.colportage[0])
                break
              default:
                break
            }
            this.$q.loading.show()
            this.$api.post('UploadFile', formData, {
              headers: {
                'Content-type': undefined
              }
            }).then(res => {
              this.$q.notify({
                position: 'center',
                textColor: 'white',
                icon: res.icon,
                color: res.color,
                message: res.message
              })
              switch (i) {
                case 'old':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Anciano'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'guieMore':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Guia Mayor'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                case 'colportage':
                  this.folder.dir = res.info[0].dir
                  this.folder.user_id = res.info[0].user_id
                  this.folder.file = 'Certificado de Colportaje'
                  this.$api.post('AddRutesOfDocuments', this.folder).then(res => {
                    console.log(res)
                  })
                  break
                default:
                  break
              }
              this.$router.push('IndexStudent')
              this.$q.loading.hide()
            })
          }
        }
      }
    }
  }
}
</script>
